/******************************************************************************************
   Class Trie and Node By Navid Hamed Azimi
   This class is supposed to get a large list of pointers to an string and create, insert,search,
   and maintain a trie of all of the strings. The trie is supposed to search only the whole strings,prefix and suffix
   It does not have the ability to search substrings.

   Class Node is supposed to be a Node of the Trie.

   myList is a link list to store the strings at the end of each trie, The reason for not using stl is memory and speed.
   each vector or other stl classes has minimum 40 byte overhead but mylist only have a size of a pointer overhead which is 8 or 4.
   Since by the calculations most of the time it will only contain one string and it will never grow more than 4 or five so we don't need
   the length parameter as well.

/******************************************************************************************/

#include "compact-trie.h"
#include <iostream>

// reportingDebug1 turn on a counter that show the status of building the first blocks of the trie.
//#define  reportingDebug1

using namespace std;

static int thirdCounter = 0;
static int counterList = 0;
static int counterNode = 0;

static int secondcounter=0;
static readPointer tempResults[200000];
static int tempResultsOffset[200000];
static int numberResultsSofar;
static int counterIt=0;
static int counterIt1=0;
static int counterIt2=0;
static int counterIt3=0;
static int counterIt4=0;
static int counterIt5=0;
static int counterIt6=0;
static int counterIt7=0;
static TrieNode* nodeTemp;
static myList* listTemp;
static int uselesscounter=0;
static int convertedString[10000];

static NavidIntPointerStruct tempStack[1000];
static int currentStackPoistion;

///////////////NEW VERSION HERE/////////////////
TrieNode::TrieNode() {
  for (int i = 0; i < alphabetNumber; i++) {
    this->isChildLeaf[i] = true;
    this->childs[i] = NULL;
  }
}

void TrieNode::destructNode() {
  for (int i = 0; i < alphabetNumber; i++) {
    if (this->isChildLeaf[i]) {
      listTemp = (myList*)this->childs[i];
      if (listTemp != NULL) delete listTemp;
    } else {
      nodeTemp = (TrieNode*)this->childs[i];
      if (nodeTemp != NULL) delete nodeTemp;
    }
  }
}

void TrieNode::addPairReadToTrie(int ID) {
  readPointer temp;
  temp.ID = ID;
  temp.status = LMAR;
  addToTrie(temp);
  temp.status = RMAR;
  addToTrie(temp);
  temp.status = LMARRC;
  addToTrie(temp);
  temp.status = RMARRC;
  addToTrie(temp);
}

void TrieNode::constructTrie() {
  int j = readsVect->TotalPairs();
  cout << endl << "number of reads added to Trie"
       << readsVect->TotalPairs() << endl;
  for (int i = 0; i < j; i++) {
    addPairReadToTrie(i);
  }
}

vector<readPointer> TrieNode::searchWithError(const string& s,int errorAllowed) {
  vector<readPointer> result;
  numberResultsSofar = 0;
  searchWithErrorAllowed(s, errorAllowed);
  result.resize(numberResultsSofar);
  for (int i = 0; i < numberResultsSofar; i++) {
    result[i] = tempResults[i];
  }
  return result;
}

void TrieNode::searchWithErrorAllowed(const string& s, int errorRemained,
				      int index) {
  if (index >= s.size()) {
    if (index == s.size()) {
      while (listTemp != NULL) {
	tempResults[numberResultsSofar] = listTemp->data;
	numberResultsSofar++;
	listTemp = listTemp->next;
      }
    }
  }
  short int i = getIndex(s[index]);
  if (errorRemained == 0) {
    if (this->childs[i] == NULL)
      return;
    if (this->isChildLeaf[i]) {
      listTemp = (myList*)(this->childs[i]);
      if (listTemp->checkString(s, index + 1, 0)) {
	while (listTemp != NULL) {
	  tempResults[numberResultsSofar] = listTemp->data;
	  numberResultsSofar++;
	  listTemp = listTemp->next;
	}
      }
    } else {
      nodeTemp = (TrieNode*)(this->childs[i]);
      nodeTemp->searchWithErrorAllowed(s, 0, index + 1);
    }
    return;
  }
  short int nextStepError;
  short int j = 0;
  for (j = 0; j < alphabetNumber; j++) {
    if (this->childs[j] != NULL) {
      if (i == j) { 
	nextStepError = errorRemained;
      } else {
	nextStepError = errorRemained-1;
      }
      if (this->isChildLeaf[j]) {
	listTemp = (myList*)(this->childs[j]);
	if (listTemp->checkString(s, index + 1, nextStepError)) {
	  while (listTemp != NULL) {
	    tempResults[numberResultsSofar] = listTemp->data;
	    numberResultsSofar++;
	    listTemp = listTemp->next;
	  }
	}
      } else {
	nodeTemp = (TrieNode*)(this->childs[j]);
	nodeTemp->searchWithErrorAllowed(s, nextStepError, index + 1);
      }
    }
  }
  return;
}

void TrieNode::addToTrie(myList* inp1, int index) {
  if (inp1->data.stringData().length() <= index) {
    if (inp1->data.stringData().length() == index) {
    } else {
      throw "error in trie add function. parsing characters of string greater than its size";
    }
    return;
  }
  int t = getIndex(inp1->data.stringData()[index]);
  if (this->childs[t] == NULL) {
    this->isChildLeaf[t] = true;
    this->childs[t] = inp1;
    return;
  } else if (this->isChildLeaf[t]) {
    listTemp = (myList*)this->childs[t];
    if (listTemp->data.stringData() == inp1->data.stringData()) {
      listTemp->addToList(inp1);
      return;
    }
    nodeTemp = new TrieNode();
    this->childs[t] = (void*)nodeTemp;
    this->isChildLeaf[t] = false;
    nodeTemp->addToTrie(listTemp, index + 1);
    nodeTemp->addToTrie(inp1, index + 1);
    return;
  }
  nodeTemp = (TrieNode*)this->childs[t];
  nodeTemp->addToTrie(inp1, index + 1);
}

NavidIntIntStruct TrieNode::traceTrie() {
  int betoch = 0;
  NavidIntIntStruct res;
  for (int j = 0; j < alphabetNumber; j++) {
    if (this->childs[j] != NULL) {
      betoch++;
      if (this->isChildLeaf[j]) {
	listTemp = (myList*)this->childs[j];
	res.leafsCount = res.leafsCount+listTemp->size();
      } else {
	nodeTemp = (TrieNode*)(this->childs[j]);
	NavidIntIntStruct res2 = nodeTemp->traceTrie();
	res.nodeCount = res.nodeCount + res2.nodeCount;
	res.leafsCount = res.leafsCount + res2.leafsCount;
      }
    }
  }
  if (betoch < 2) {
    uselesscounter++;
  }
  res.nodeCount = res.nodeCount + 1;
  return res;
}

void TrieNode::searchWithErrorAllowedNonRecursive(const string& s,
						  int errorRemained) {
  currentStackPoistion = 0;
  tempStack[currentStackPoistion].currentNode = this;
  tempStack[currentStackPoistion].AlphabetParsed = 0;
  int ssize = s.size();
  tempStack[currentStackPoistion].currentError = errorRemained;
  int i;
  for (i = 0; i < ssize; i++)
    convertedString[i] = getIndex(s[i]);
#define curNode tempStack[currentStackPoistion].currentNode
#define currentParse tempStack[currentStackPoistion].AlphabetParsed
  int errorAllowed;
  while (currentStackPoistion >= 0) {
    if (!(currentParse < alphabetNumber)) {
      currentStackPoistion--;
      tempStack[currentStackPoistion].AlphabetParsed++;
      continue;
    }
    i = convertedString[currentStackPoistion];
    if (i == currentParse) {
      errorAllowed = tempStack[currentStackPoistion].currentError;
    } else {
      errorAllowed = tempStack[currentStackPoistion].currentError - 1;
    }
    if (curNode->childs[currentParse] != NULL) {
      if (errorAllowed <= 0) {
	int index = currentStackPoistion;
	i = convertedString[index];
	while (!(curNode->isChildLeaf[i])) {
	  curNode = (TrieNode*)curNode->childs[i];
	  index++;
	  i = convertedString[index];
	}
	if (curNode->childs[i] == NULL) {
	} else {
	  listTemp = (myList*)(curNode->childs[i]);
	  if (listTemp->checkString(s, index + 1, 0)) {
	    while (listTemp != NULL) {
	      tempResults[numberResultsSofar] = listTemp->data;
	      numberResultsSofar++;
	      listTemp = listTemp->next;
	    }
	  }
	}
      } else if (curNode->childs[currentParse] != NULL) {
	if (curNode->isChildLeaf[currentParse]) {
	  listTemp = (myList*)(curNode->childs[currentParse]);
	  if (listTemp->checkString(s, currentStackPoistion + 1,
				    errorAllowed)) {
	    while (listTemp != NULL) {
	      tempResults[numberResultsSofar] = listTemp->data;
	      numberResultsSofar++;
	      listTemp = listTemp->next;
	    }
	  }
	} else {
	  nodeTemp = (TrieNode*)(curNode->childs[currentParse]);
	  currentStackPoistion++;
	  tempStack[currentStackPoistion].currentNode = nodeTemp;
	  tempStack[currentStackPoistion].AlphabetParsed = 0;
	  tempStack[currentStackPoistion].currentError = errorAllowed;
	  continue;
	}
      }    
    }
    tempStack[currentStackPoistion].AlphabetParsed++;
  }
}

void TrieNode::searchWithErrorWholeSeed(const string& s, int errorAllowed,
					int readSize, IntIntMtTripleVec& left,
					IntIntMtTripleVec& right) {
  numberResultsSofar = 0;
  for (int i = 0; i < s.length() - readSize; i++) {
    int offset = numberResultsSofar;
    string t = s.substr(i, readSize);
    searchWithErrorAllowedNonRecursive(t, errorAllowed);
    for (int j = offset; j < numberResultsSofar; j++) {
      tempResultsOffset[j] = i;
    }
  }
  cout << "search level 2 iscompleted" << endl;
  int leftNum = 0;
  int rightNum = 0;
  for (int i = 0; i < numberResultsSofar; i++) {
    if (tempResultsOffset[i] > -1) {
      if ((tempResults[i].status == LMAR) ||
	  (tempResults[i].status == LMARRC)) {
	leftNum++;
      } else if ((tempResults[i].status == RMAR) ||
		 (tempResults[i].status == RMARRC)) {
	rightNum++;
      }
    }
  }
  left.resize(leftNum);
  right.resize(rightNum);
  int leftIndex = 0;
  int rightIndex = 0;
  for (int i = 0; i < numberResultsSofar; i++) {
    if ((tempResults[i].status == LMAR) || (tempResults[i].status == LMARRC)) {
      left[leftIndex].first = tempResults[i].ID;
      left[leftIndex].second = tempResultsOffset[i];
      left[leftIndex].third = tempResults[i].status;
      leftIndex++;
    } else if ((tempResults[i].status == RMAR) ||
	       (tempResults[i].status == RMARRC)) {
      right[rightIndex].first = tempResults[i].ID;
      right[rightIndex].second = tempResultsOffset[i];
      right[rightIndex].third = tempResults[i].status;
      rightIndex++;
    }
  }
  return;
}

IntIntMtTripleVec TrieNode::searchWithErrorWholeSeed(const string& s, int errorAllowed, int readSize) {
  numberResultsSofar = 0;
  for (int i = 0; i < s.length() - readSize; i++) {
    int offset = numberResultsSofar;
    string t = s.substr(i, readSize);
    searchWithErrorAllowedNonRecursive(t, errorAllowed);
    for (int j = offset; j < numberResultsSofar; j++) {
      tempResultsOffset[j] = i;
    }
  }
  IntIntMtTripleVec results;
  results.resize(numberResultsSofar);
  for (int i = 0; i < numberResultsSofar; i++) {
      results[i].first = tempResults[i].ID;
      results[i].second = tempResultsOffset[i];
      results[i].third = tempResults[i].status;
  }
  return results;
}


IntMtPair TrieNode::Search(const string& s) {
  numberResultsSofar=0;
  searchWithErrorAllowedNonRecursive(s, 0);
  IntMtPair result;
  result.first=-1;
  if (numberResultsSofar>0) {
    result.first=tempResults[0].ID;
    result.second=tempResults[0].status;
  }
  return result;
}

void TrieNode::Insert(int ID, mar_types status) {
  readPointer temp;
  temp.ID = ID;
  temp.status = status;
  addToTrie(temp);
}
