#include "homo-poly.h"

//using namespace std;

int HomoPoly::MAX_VAL = 1 << 7;

HomoPoly::HomoPoly() {
  fill(base_, base_ + BASE_TYPES, 0);
}

HomoPoly::HomoPoly(const HomoPoly& hp) {
  for (int i = 0; i < BASE_TYPES; ++i) {
    base_[(base_types)i] = hp[(base_types)i];
  }
}

HomoPoly::HomoPoly(int a, int t, int g, int c) {
  base_[BASEA] = a >= MAX_VAL ? MAX_VAL - 1 : a;
  base_[BASET] = t >= MAX_VAL ? MAX_VAL - 1 : t;
  base_[BASEG] = g >= MAX_VAL ? MAX_VAL - 1 : g;
  base_[BASEC] = c >= MAX_VAL ? MAX_VAL - 1 : c;
  
  assert(base_[BASEA] >= 0 && base_[BASEA] < MAX_VAL);
  assert(base_[BASET] >= 0 && base_[BASET] < MAX_VAL);
  assert(base_[BASEG] >= 0 && base_[BASEG] < MAX_VAL);
  assert(base_[BASEC] >= 0 && base_[BASEC] < MAX_VAL);
}

void HomoPoly::Update(base_types bt, int x) {
  base_[bt] = max((int)base_[bt], (x >= MAX_VAL ? MAX_VAL - 1 : x));
}

char HomoPoly::operator [] (base_types i) const {
  return base_[i];
}

char& HomoPoly::operator [] (base_types i) {
  return base_[i];
}
