#ifndef HOMO_POLY_H
#define HOMO_POLY_H

#include "header.h"

// When dealing with homo polymer errors (e.g., Helicos), we use this class to
// keep track of homo-polymer information.
class HomoPoly {
 public:
  HomoPoly();
  HomoPoly(int a, int t, int g, int c);
  HomoPoly(const HomoPoly& hp);

  void Update(base_types bt, int x);

  char operator [] (base_types i) const;
  char& operator [] (base_types i);

 private:
  static int MAX_VAL;
  char base_[BASE_TYPES];  // Be careful so that the count always stays below 1 << 7.
};

#endif  // HOMO_POLY_H
