#ifndef RANDOM_ACCESS_VECTOR_H
#define RANDOM_ACCESS_VECTOR_H

#include "header.h"

template<class T>
class RandomAccessVector {
 public:
  RandomAccessVector() { total = 0; }
  T GetAnElement() {
    int pos;
    do {
      pos = rand() % dat_.size();
    } while(!valid_[pos]);
    --total;
    valid_[pos] = false;
    empty_pos_.push(pos);
    return dat_[pos];
  }
  void AddAnElement(const T& v) {
    ++total;
    if (!empty_pos_.empty()) {
      int pos = empty_pos_.top();
      empty_pos_.pop();
      dat_[pos] = v;
      valid_[pos] = true;
    } else {
      dat_.push_back(v);
      valid_.push_back(true);
    }
  }
  bool Empty() { return total == 0; }
 private:
  int total;
  vector<T> dat_;
  vector<bool> valid_;
  stack<int> empty_pos_;
};

#endif  // RANDOM_ACCESS_VECTOR_H
