#include "header.h"

// Stores information about a contig.
class VizContig {
 public:
  // Constructors.
  VizContig(const string& str, int r = -1, int c = -1) 
    { contig_ = str; row_ = r, col_ = c; }

  // Getter methods.
  inline int row() const { return row_; }
  inline int col() const { return col_; }
  inline string contig() const { return contig_; }

  // Setter methods.
  inline void setRow(int r) { row_ = r; }
  inline void setCol(int c) { col_ = c; }
  inline void setContig(const string& str) { contig_ = str; }
  inline void AddRead(int id) { reads_.push_back(id); }

 private:
  int row_;  // Row in which this contig will appear.
  int col_;  // Column in which this contig will appear.
  string contig_; // Actual contig.

  // Participating reads in this contig.
  vector<int> reads_;
};

// A class to implement the comparator for Contig.
class CompareContig {
 public:
  bool operator()(const VizContig& a, const VizContig& b) {
    if (a.row() > b.row()) return true;
    if (a.row() == b.row()) return a.col() < b.col();
    return false;
  }
};
