#include <iostream>
#include <fstream>
#include <map>
#include <vector>

using namespace std;

vector<string> lmar, rmar;
vector<double> lqual, rqual;
vector<string> sids;
map<string, int> id;

void Convert(string& str) {
  for (int i = 1; i < str.size(); ++i) {
    if (str[i] == '0') {
      str[i] = 'A';
    } else if (str[i] == '1') {
      str[i] = 'T';
    } else if (str[i] == '2') {
      str[i] = 'G';
    } else if (str[i] == '3') {
      str[i] = 'C';
    } else {
      cout << "problem!!!\n";
      exit(1);
    }
  }
}

int main(int argc, char** argv) {
  if (argc != 5) {
    cout << "usage: abi2shorty lfile rfile lqual rqual\n";
    exit(1);
  }
  fstream fin1(argv[1], ios::in);
  string a;
  int gc = 0;
  while (getline(fin1, a)) {
    if (a[0] == '#') continue;
    a = a.substr(1, a.size() - 4);
    //cout << a << endl;
    int pos = id[a];
    string ta = a;
    if (pos == 0) {
      pos = id[a] = ++gc;
      getline(fin1, a);
      lmar.push_back(a);
      sids.push_back(ta);
    } else {
      getline(fin1, a);
      lmar[pos - 1] = a;
    }
    //    cout << gc << endl;
  }
  lqual.resize(lmar.size());
  fstream finlq(argv[3], ios::in);
  while (finlq >> a) {
    a = a.substr(1, a.size() - 4);
    double x = 0;
    for (int i = 0; i < 25; ++i) {
      int s;
      finlq >> s;
      x += s;
    }
    x /= 25;
    int pos = id[a];
    if (pos != 0) {
      lqual[pos - 1] = x;
    }
  }
  rqual.resize(lmar.size());
  fstream finrq(argv[4], ios::in);
  while (finrq >> a) {
    a = a.substr(1, a.size() - 4);
    double x = 0;
    for (int i = 0; i < 25; ++i) {
      int s;
      finrq >> s;
      x += s;
    }
    x /= 25;
    int pos = id[a];
    if (pos != 0) {
      rqual[pos - 1] = x;
    }
  }
  //  cout << lmar.size() << endl;
  rmar.resize(lmar.size());
  fstream fin2(argv[2], ios::in);
  while (getline(fin2, a)) {
    if (a[0] == '#') continue;
    a = a.substr(1, a.size() - 4);
    int pos = id[a];
    if (pos != 0) {
      getline(fin2, a);
      rmar[pos - 1] = a;
    }
  }
  gc = 0;
  for (int i = 0; i < lmar.size(); ++i) {
    if (rmar[i].size() == 0 || lqual[i] < 15.0 || rqual[i] < 15.0) continue;
    //    Convert(lmar[i]);
    //Convert(rmar[i]);
    cout << ">a:" << sids[i] << endl << lmar[i] << endl;
    cout << ">b:" << sids[i] << endl << rmar[i] << endl;
    ++gc;
  }
  //  cout << gc << endl;
  fin1.close();
  fin2.close();
  finlq.close();
  finrq.close();
  return 0;
}
