#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <algorithm>

using namespace std;

char int2base_[4];
char charchar2color_[256][256];

void Init() {
  charchar2color_['A']['A'] = 0;
  charchar2color_['A']['C'] = 1;
  charchar2color_['A']['G'] = 2;
  charchar2color_['A']['T'] = 3;

  charchar2color_['C']['A'] = 1;
  charchar2color_['C']['C'] = 0;
  charchar2color_['C']['G'] = 3;
  charchar2color_['C']['T'] = 2;

  charchar2color_['G']['A'] = 2;
  charchar2color_['G']['C'] = 3;
  charchar2color_['G']['G'] = 0;
  charchar2color_['G']['T'] = 1;

  charchar2color_['T']['A'] = 3;
  charchar2color_['T']['C'] = 2;
  charchar2color_['T']['G'] = 1;
  charchar2color_['T']['T'] = 0;
  
  int2base_[0] = 'A';
  int2base_[1] = 'T';
  int2base_[2] = 'G';
  int2base_[3] = 'C';
}

string Fasta2Solid(const string& a) {
  //Initialize();
  string ret = "";
  for (int i = 1; i < a.size(); ++i) {
    ret.push_back(int2base_[charchar2color_[a[i - 1]][a[i]]]);
  }
  return ret;
}

int main() {
  Init();
  string s;
  while (cin >> s) {
    string t = Fasta2Solid(s);
    cout << ">+\n" << t << endl;
    reverse(t.begin(), t.end());
    cout << ">-\n" << t << endl;
  }
  return 0;
}
